;*************************************
;** Source of the TraPatch-handlers **
;**      (for Pure-Assembler)       **
;**       (c) Jrg Westheide        **
;*************************************

.align 4
                .dc.l 'XBRA'
                .dc.l 'TraP'
old_gemdos_vec: .dc.l 0
                
new_gemdos:

        move.l usp, a0
        
        btst #5, (sp)
        beq  g_parmptr_set
        
        move.l sp, a0
        adda.w longframe, a0
        
g_parmptr_set:
        
        move.w (a0)+, d0
        
        cmp.w gemdos_entries(pc), d0   ; Funktionnumber in table?
        bcc call_gemdos
        
get_gemdos_vec:
        
        add.w d0, d0
        add.w d0, d0
        
        subq.w #8, sp               ; for saving a1
        move.l a1, (sp)             ; for saving a1
        
        movea.l tab_gemdos(pc), a1
        move.l 0(a1, d0.w), 4(sp)   ; for saving a1, else -(sp)
        
        move.l (sp)+, a1            ; for saving a1
        
        rts

.align 4        
        .dc.l 'XBRA'      ; XBRA structure for the end of the internal chain
        .dc.l 'TraP'
        .dc.l 0
call_gemdos:              ; default entry in the GEMDOS table
        
        move.l old_gemdos_vec, a0
        jmp (a0)
        
        
.align 4        
        .dc.l 'XBRA'
        .dc.l 'TraP'
old_bios_vec:
        .dc.l 0
                
new_bios:
        
        move.l usp, a0
        
        btst #5, (sp)
        beq  b_parmptr_set
        
        move.l sp, a0
        adda.w longframe, a0
        
b_parmptr_set:
        
        movea.l tab_bios(pc), a1
        
        move.w (a0)+, d0
        
        cmp.w bios_entries(pc), d0
        bcc call_bios
        
get_bios_vec:
        
        add.w d0, d0
        add.w d0, d0
        
        movea.l 0(a1, d0.w), a1
        
        jmp(a1)
        
        
.align 4
        .dc.l 'XBRA'   ; XBRA structure for the end of the internal chain
        .dc.l 'TraP'
        .dc.l 0
call_bios:             ; default entry in the BIOS table
        
        movea.l old_bios_vec(pc), a0
        jmp (a0)
        
        
                
.align 4
        .dc.l 'XBRA'
        .dc.l 'TraP'
old_xbios_vec:
        .dc.l 0
                
new_xbios:
        
        move.l usp, a0
        
        btst #5, (sp)
        beq  x_parmptr_set
        
        move.l sp, a0
        adda.w longframe, a0
        
x_parmptr_set:
        
        movea.l tab_xbios(pc), a1
        
        move.w (a0)+, d0

        cmp.w xbios_entries(pc), d0
        bcc call_xbios
        
get_xbios_vec:
        
        add.w d0, d0
        add.w d0, d0
        
        move.l 0(a1, d0.w), a1
        jmp(a1)
        
        
.align 4
        .dc.l 'XBRA'    ; XBRA structure for the end of the internal chain
        .dc.l 'TraP'
        .dc.l 0         ; default entry in the XBIOS table
call_xbios:
        
        movea.l old_xbios_vec(pc), a0
        jmp (a0)
        
        
                
.align 4
        .dc.l 'XBRA'
        .dc.l 'TraP'
old_gem_vec:
        .dc.l 0
                
new_gem:
        
        cmpi.w #200, d0
        bne call_gem
        
        move.l d1, a0
        
        move.l (a0), a0     ; control array
        move.w (a0), d0     ; function number
        
        cmp.w gem_entries(pc), d0
        bcc call_aes
        
        move.l tab_gem(pc), a0
        add.w d0, d0
        add.w d0, d0
        move.l 0(a0, d0.w), a0
        
        move.w #200, d0
        
        jmp (a0)
        

.align 4        
call_aes: 
        
        move.w #200, d0
        bra call_gem
        

.align 4
        .dc.l 'XBRA'    ; XBRA structure for the end of the internal chain
        .dc.l 'TraP'
        .dc.l 0
call_gem:               ; default entry in the AES table
        
        movea.l old_gem_vec(pc), a0
        jmp (a0)
        