;**********************************
;** Sourcen der TraPatch-Handler **
;**     (fr Pure-Assembler)     **
;**      (c) Jrg Westheide      **
;**********************************

.align 4
                .dc.l 'XBRA'
                .dc.l 'TraP'
old_gemdos_vec: .dc.l 0
                
new_gemdos:

        move.l usp, a0
        
        btst #5, (sp)
        beq  g_parmptr_set
        
        move.l sp, a0
        adda.w longframe, a0
        
g_parmptr_set:
        
        move.w (a0)+, d0
        
        cmp.w gemdos_entries(pc), d0   ; Funktionsnummer von Tabelle abgedeckt?
        bcc call_gemdos
        
get_gemdos_vec:
        
        add.w d0, d0
        add.w d0, d0
        
        subq.w #8, sp               ; wegen Rettung von a1
        move.l a1, (sp)             ; wegen Rettung von a1
        
        movea.l tab_gemdos(pc), a1
        move.l 0(a1, d0.w), 4(sp)   ; wegen Rettung von a1, sonst -(sp)
        
        move.l (sp)+, a1            ; wegen Rettung von a1
        
        rts

.align 4        
        .dc.l 'XBRA'      ; XBRA-Struktur fr Ende der internen Kette
        .dc.l 'TraP'
        .dc.l 0
call_gemdos:              ; Default-Eintrag in der GEMDOS-Tabelle
        
        move.l old_gemdos_vec, a0
        jmp (a0)
        
        
.align 4        
        .dc.l 'XBRA'
        .dc.l 'TraP'
old_bios_vec:
        .dc.l 0
                
new_bios:
        
        move.l usp, a0
        
        btst #5, (sp)
        beq  b_parmptr_set
        
        move.l sp, a0
        adda.w longframe, a0
        
b_parmptr_set:
        
        movea.l tab_bios(pc), a1
        
        move.w (a0)+, d0
        
        cmp.w bios_entries(pc), d0
        bcc call_bios
        
get_bios_vec:
        
        add.w d0, d0
        add.w d0, d0
        
        movea.l 0(a1, d0.w), a1
        
        jmp(a1)
        
        
.align 4
        .dc.l 'XBRA'   ; XBRA-Struktur fr Ende der internen Kette
        .dc.l 'TraP'
        .dc.l 0
call_bios:             ; Default-Eintrag in der BIOS-Tabelle
        
        movea.l old_bios_vec(pc), a0
        jmp (a0)
        
        
                
.align 4
        .dc.l 'XBRA'
        .dc.l 'TraP'
old_xbios_vec:
        .dc.l 0
                
new_xbios:
        
        move.l usp, a0
        
        btst #5, (sp)
        beq  x_parmptr_set
        
        move.l sp, a0
        adda.w longframe, a0
        
x_parmptr_set:
        
        movea.l tab_xbios(pc), a1
        
        move.w (a0)+, d0

        cmp.w xbios_entries(pc), d0
        bcc call_xbios
        
get_xbios_vec:
        
        add.w d0, d0
        add.w d0, d0
        
        move.l 0(a1, d0.w), a1
        jmp(a1)
        
        
.align 4
        .dc.l 'XBRA'    ; XBRA-Struktur fr Ende der internen Kette
        .dc.l 'TraP'
        .dc.l 0         ; Default-Eintrag in der XBIOS-Tabelle
call_xbios:
        
        movea.l old_xbios_vec(pc), a0
        jmp (a0)
        
        
                
.align 4
        .dc.l 'XBRA'
        .dc.l 'TraP'
old_gem_vec:
        .dc.l 0
                
new_gem:
        
        cmpi.w #200, d0
        bne call_gem
        
        move.l d1, a0
        
        move.l (a0), a0     ; Control
        move.w (a0), d0     ; fktnum
        
        cmp.w gem_entries(pc), d0
        bcc call_aes
        
        move.l tab_gem(pc), a0
        add.w d0, d0
        add.w d0, d0
        move.l 0(a0, d0.w), a0
        
        move.w #200, d0
        
        jmp (a0)
        

.align 4        
call_aes: 
        
        move.w #200, d0
        bra call_gem
        

.align 4
        .dc.l 'XBRA'    ; XBRA-Struktur fr Ende der internen Kette
        .dc.l 'TraP'
        .dc.l 0
call_gem:               ; Default-Eintrag in der AES-Tabelle
        
        movea.l old_gem_vec(pc), a0
        jmp (a0)
        